SystemOrganization addCategory: #AttractorModelisation!

DynamicComposableModel subclass: #UISecondVersion
	instanceVariableNames: 'modelview xtview ytview ztview plus slider lcolor varValues minus attr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!UISecondVersion methodsFor: 'initialization' stamp: ''!
initialize
	self initialize: Attractor new! !

!UISecondVersion methodsFor: 'initialization' stamp: ''!
initialize: arg1
	attr := arg1.
	super initialize.
	self
		initializeWidgets;
		extent: 600 @ 480! !

!UISecondVersion methodsFor: 'initialization' stamp: ''!
initializeWidgets
	| tmp2 tmp12 tmp14 tmp16 |
	self
		instantiateModels: #(#view #RoassalModel #xtview #RoassalModel #ytview #RoassalModel #ztview #RoassalModel #plus #ButtonModel #slider #SliderModel #lcolor #CheckBoxModel #varValues #LabelModel #minus #ButtonModel).
	tmp2 := SpecLayout composed.
	tmp2
		newColumn: [ :arg1 | 
			| tmp4 |
			tmp4 := arg1.
			tmp4
				add: #view;
				newRow: [ :arg2 | 
					| tmp6 |
					tmp6 := arg2.
					tmp6
						add: #xtview;
						addSplitter;
						add: #ytview;
						addSplitter;
						add: #ztview ];
				newRow: [ :arg3 | 
					| tmp8 |
					tmp8 := arg3.
					tmp8
						add: #lcolor;
						add: #varValues;
						add: #slider ]
					height: 25;
				newRow: [ :arg4 | 
					| tmp10 |
					tmp10 := arg4.
					tmp10
						add: #minus;
						addSplitter;
						add: #plus ]
					height: 25 ].
	layout := tmp2 yourself.
	self view
		script: [ :arg5 :arg6 | 
			arg5 addAll: attr elements.
			arg6 camera focusOnCenter ].
	xtview := RoassalModel new.
	ytview := RoassalModel new.
	ztview := RoassalModel new.
	self xtview
		script: [ :arg7 :arg8 | 
			arg7 addAll: (attr elementsForGraphAt: 1).
			arg8 camera focusOnCenter ].
	self ytview
		script: [ :arg9 :arg10 | 
			arg9 addAll: (attr elementsForGraphAt: 2).
			arg10 camera focusOnCenter ].
	self ztview
		script: [ :arg11 :arg12 | 
			arg11 addAll: (attr elementsForGraphAt: 3).
			arg12 camera focusOnCenter ].
	tmp12 := self minus.
	tmp12
		label: 'r--';
		state: false;
		action: [ attr r: attr r - 1.
			self refresh ].
	tmp14 := self plus.
	tmp14
		label: 'r++';
		state: false;
		action: [ attr r: attr r + 1.
			self refresh ].
	varValues := LabelModel new.
	self varValues
		label: 'sigma=' , attr sigma asString , '   r=' , attr r asString.
	lcolor := CheckBoxModel new.
	self lcolor
		whenChangedDo: [ :arg13 | 
			arg13
				ifTrue: [ attr ds connectColor: Color green.
					self refresh ]
				ifFalse: [ attr ds
						disconnect;
						connectColor: Color transparent.
					self refresh ] ].
	tmp16 := self slider.
	tmp16
		whenValueChangedDo: [ :arg14 | 
			attr sigma: arg14.
			self refresh ];
		min: 0;
		max: 10;
		label: '0< sigma <=10'! !

!UISecondVersion methodsFor: 'accessing' stamp: ''!
layout
	^ layout! !

!UISecondVersion methodsFor: 'accessing' stamp: ''!
lcolor
	^ lcolor! !

!UISecondVersion methodsFor: 'use' stamp: ''!
openView
	self openWithSpecLayout: layout! !

!UISecondVersion methodsFor: 'use' stamp: ''!
refresh
	attr rebuild.
	self varValues
		label: 'sigma=' , attr sigma asString , '   r=' , attr r asString.
	self
		needRebuild: false;
		buildWithSpecLayout: layout! !

!UISecondVersion methodsFor: 'accessing' stamp: ''!
varValues
	^ varValues! !

!UISecondVersion methodsFor: 'accessing' stamp: ''!
xtview
	^ xtview! !

!UISecondVersion methodsFor: 'accessing' stamp: ''!
ytview
	^ ytview! !

!UISecondVersion methodsFor: 'accessing' stamp: ''!
ztview
	^ ztview! !

Object subclass: #Attractor
	instanceVariableNames: 'sigma r p dt initState values b attrView xValues yValues zValues graphList viewList ds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!Attractor methodsFor: 'accessing' stamp: ''!
b
	^ b! !

!Attractor methodsFor: 'builders' stamp: ''!
buildRTGrapher
	| tmp2 tmp4 |
	b := RTGrapher new.
	ds := RTData new.
	tmp2 := ds dotShape ellipse.
	tmp2
		size: 1;
		color: Color blue.
	ds points: values.
	tmp4 := ds.
	tmp4
		x: [ :arg1 | arg1 at: 1 ];
		y: [ :arg2 | arg2 at: 2 ].
	b
		add: ds;
		build! !

!Attractor methodsFor: 'builders' stamp: ''!
buildRTGrapher: arg1
	| tmp1 tmp2 tmp4 |
	tmp1 := RTGrapher new.
	tmp2 := RTData new.
	tmp4 := tmp2 dotShape ellipse.
	tmp4
		size: 1;
		color: Color red.
	tmp2
		points: arg1;
		connectColor: Color red.
	tmp1
		add: tmp2;
		build.
	graphList add: tmp1! !

!Attractor methodsFor: 'builders' stamp: ''!
buildRTGrapher: arg1 withColor: arg2
	| tmp1 tmp2 tmp4 |
	tmp1 := RTGrapher new.
	tmp2 := RTData new.
	tmp4 := tmp2 dotShape ellipse.
	tmp4
		size: 1;
		color: Color blue.
	tmp2
		points: arg1;
		connectColor: Color color;
		y: #yourself.
	tmp1
		add: tmp2;
		shouldUseNiceLabels: true;
		build.
	graphList add: tmp1! !

!Attractor methodsFor: 'hooks' stamp: ''!
buildView
	| tmp1 |
	attrView := RTView new.
	attrView @ RTDraggableView.
	tmp1 := b view elements , b view edges.
	attrView addAll: tmp1.
	attrView canvas camera
		noInitializationWhenOpen;
		scale: 1.5.
	^ attrView! !

!Attractor methodsFor: 'hooks' stamp: ''!
buildView: arg1
	| tmp1 tmp2 |
	tmp1 := RTView new.
	tmp1 @ RTDraggableView.
	tmp2 := arg1 view elements , arg1 view edges.
	tmp1 addAll: tmp2.
	tmp1 canvas camera
		noInitializationWhenOpen;
		scale: 1.5.
	viewList add: tmp1.
	^ tmp1! !

!Attractor methodsFor: 'accessing' stamp: ''!
ds
	^ ds! !

!Attractor methodsFor: 'accessing' stamp: ''!
dt: arg1
	dt := arg1! !

!Attractor methodsFor: 'accessing' stamp: ''!
elements
	^ b view elements! !

!Attractor methodsFor: 'accessing' stamp: ''!
elementsForGraphAt: arg1
	^ (graphList at: arg1) view elements! !

!Attractor methodsFor: 'accessing' stamp: ''!
initState: arg1
	initState := arg1! !

!Attractor methodsFor: 'initialization' stamp: ''!
initialize
	| tmp1 tmp2 tmp3 tmp5 tmp13 |
	graphList := OrderedCollection new.
	viewList := OrderedCollection new.
	sigma := 10.0.
	r := 28.0.
	p := 8.0 / 3.0.
	dt := 0.1.
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	zValues := OrderedCollection new.
	tmp3 := ExplicitSystem
		block: [ :arg1 :arg2 | 
			| tmp6 tmp7 tmp8 tmp9 tmp10 tmp11 |
			tmp9 := arg1 at: 1.
			tmp10 := arg1 at: 2.
			tmp11 := arg1 at: 3.
			xValues add: tmp9.
			yValues add: tmp10.
			zValues add: tmp11.
			tmp6 := sigma * (tmp10 - tmp9).
			tmp7 := r * tmp9 - tmp10 - (tmp9 * tmp11).
			tmp8 := -1 * p * tmp11 + (tmp9 * tmp10).
			{tmp6.
			tmp7.
			tmp8} ].
	tmp1 := RungeKuttaStepper onSystem: tmp3.
	tmp13 := ExplicitSolver new.
	tmp13
		stepper: tmp1;
		system: tmp3.
	tmp2 := tmp13 dt: dt.
	tmp5 := #(10.0 10.0 10.0).
	values := (0.0 to: 100.0 by: dt)
		collect: [ :arg3 | tmp5 := tmp1 doStep: tmp5 time: arg3 stepSize: dt ].
	self
		buildRTGrapher: xValues;
		buildRTGrapher: yValues;
		buildRTGrapher: zValues;
		buildRTGrapher.
	viewList do: [ :arg4 | self buildView: arg4 ].
	self buildView! !

!Attractor methodsFor: 'builders' stamp: ''!
openRTGrapher
	b open! !

!Attractor methodsFor: 'accessing' stamp: ''!
p: arg1
	p := arg1! !

!Attractor methodsFor: 'accessing' stamp: ''!
r
	^ r! !

!Attractor methodsFor: 'accessing' stamp: ''!
r: arg1
	r := arg1! !

!Attractor methodsFor: 'builders' stamp: ''!
rebuild
	b build! !

!Attractor methodsFor: 'actions' stamp: ''!
refresh
	attrView signalUpdate! !

!Attractor methodsFor: 'accessing' stamp: ''!
sigma
	^ sigma! !

!Attractor methodsFor: 'accessing' stamp: ''!
sigma: arg1
	sigma := arg1! !

!Attractor methodsFor: 'accessing' stamp: ''!
values: arg1
	values := arg1! !

!Attractor methodsFor: 'accessing' stamp: ''!
view
	^ attrView! !
